<?php if ( ! defined( 'ABSPATH' ) ) exit;

function ddomenus_is_slider ($render_slug) {
    return $render_slug === 'et_pb_slider' || $render_slug === 'et_pb_fullwidth_slider' || $render_slug === 'et_pb_video_slider' || $render_slug === 'et_pb_post_slider' || $render_slug === 'et_pb_fullwidth_post_slider'; 
}

function ddomenus_is_portfolio ($render_slug) {
    return $render_slug === 'et_pb_blog' || $render_slug === 'et_pb_portfolio' || $render_slug === 'et_pb_fullwidth_portfolio' || $render_slug === 'et_pb_filterable_portfolio'; 
}

function ddomenus_process_shortcode($divimenu_id, $position) {	
    if (empty($divimenu_id)) return;
    $post = get_post( $divimenu_id );
    if ($post) {
        $shortcode = $post->post_content;
        $menu_alignment = strpos($shortcode, 'menu_alignment') !== false; // the menu alignment default value is justified 
        if ($menu_alignment && ($position === 'tl' || $position === 'ml' || $position === 'bl') )
            $shortcode = preg_replace('/menu_alignment="(.*?)"/', 'menu_alignment="left"', $shortcode);
        else if ($menu_alignment && ($position === 'tc' || $position === 'mc' || $position === 'bc') )
            $shortcode = preg_replace('/menu_alignment="(.*?)"/', '', $shortcode);
        else if ($menu_alignment && ($position === 'tr' || $position === 'mr' || $position === 'br') )
            $shortcode = preg_replace('/menu_alignment="(.*?)"/', 'menu_alignment="right"', $shortcode);
        else if ($position === 'tl' || $position === 'ml' || $position === 'bl')
            $shortcode = str_replace('[et_pb_divimenus ', '[et_pb_divimenus menu_alignment="left" ', $shortcode);
        else if ($position === 'tr' || $position === 'mr' || $position === 'br') 
            $shortcode = str_replace('[et_pb_divimenus ', '[et_pb_divimenus menu_alignment="right" ', $shortcode);
        return do_shortcode( $shortcode );
    }
    return '';
}

function ddomenus_module_output ($output, $render_slug, $module) {
    $location = $module->props['divimenu_location'];
    $style = ddomenus_set_overlay_style($render_slug, $module, '%%order_class%% .divimenu-overlay');	
    $overlay = sprintf('<div class="divimenu-overlay divimenu-overlay-%2$s%3$s%4$s%5$s">%1$s%6$s</div>', 
        ddomenus_process_shortcode($module->props['divimenu_overlay'], $location),
        $location,
        $style['desktop'],
        $style['tablet'],
        $style['phone'],
        $render_slug === 'et_pb_video' ? sprintf( '<a href="%1$s"></a>', esc_attr( $module->props['src'] )) : '' 
    );
    $output = str_replace('et_pb_gallery_items et_post_gallery ', 'et_pb_gallery_items ', $output);				
    return $output . $overlay;
}

function ddomenus_set_overlay_style($render_slug, $module, $selector) {
    $hover_selector = '%%order_class%%.divimenu-overlay-container:hover .divimenu-overlay, %%order_class%% .divimenu-overlay-container:hover .divimenu-overlay';;
    if ( $module->props['divimenu_overlay_color'] !== '') {
        ET_Builder_Element::set_style( $render_slug, array(
            'selector'    => $selector,
            'declaration' => sprintf( 'background-color: %1$s;', esc_html($module->props['divimenu_overlay_color'])),
        ) );
        if (et_pb_hover_options()->is_enabled( 'divimenu_overlay_color', $module->props ))
            ET_Builder_Element::set_style( $render_slug, array(
                'selector'    => $hover_selector, 
                'declaration' => sprintf('background-color: %1$s;', esc_attr($module->props["divimenu_overlay_color__hover"])) 					
            ) );
    }

    $style = array( 'desktop' => '', 'tablet' => '', 'phone' => '' );

    if ($module->props['divimenu_show'] === 'always') $style['desktop'] = ' dd-show-desktop';
    else if ($module->props['divimenu_show'] === 'hover') $style['desktop'] = ' dd-hover-desktop';
  
    if (et_pb_responsive_options()->is_responsive_enabled( $module->props, 'divimenu_show' )) {       
        if (!isset($module->props['divimenu_show_tablet'])) $module->props['divimenu_show_tablet'] =  $module->props['divimenu_show'];
        if (!isset($module->props['divimenu_show_phone'])) $module->props['divimenu_show_phone'] =  $module->props['divimenu_show_tablet'];

        if ($module->props['divimenu_show_tablet'] === 'always') $style['tablet'] = ' dd-show-tablet';
        else if ($module->props['divimenu_show_tablet'] ==='hover') $style['tablet'] = ' dd-hover-tablet'; 
        
        if ($module->props['divimenu_show_phone'] === 'always') $style['phone'] = ' dd-show-mobile';
        else if ($module->props['divimenu_show_phone'] ==='hover') $style['phone'] = ' dd-hover-mobile';  
    } 
    return $style;       
}